/***********************************************************************
 * Copyright (c) 2003 University of Kent.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.cs.kent.ac.uk/projects/ocl/CPL.html
 ***********************************************************************/

package uk.ac.kent.cs.ocl20.bridge4kmf;

import uk.ac.kent.cs.ocl20.OclProcessor;
import uk.ac.kent.cs.ocl20.semantics.*;
import uk.ac.kent.cs.ocl20.semantics.bridge.*;

/**
 * @author Octavian Patrascoiu
 *
 */

public class EnumLiteralImpl implements EnumLiteral {
	/** Construct a Enumeration Literal */
	public EnumLiteralImpl(uk.ac.ukc.cs.kmf.kmfstudio.uml.Foundation.Core.EnumLiteral enumLit, Enumeration_ enum, OclProcessor proc) {
		this.processor = proc;
		this.enumLit = enumLit;
		this.enum = enum;
	}
	protected OclProcessor processor;

	/** Wrapped UML correspondent */
	protected uk.ac.ukc.cs.kmf.kmfstudio.uml.Foundation.Core.EnumLiteral enumLit;
	public uk.ac.ukc.cs.kmf.kmfstudio.uml.Foundation.Core.EnumLiteral getImpl() {
		return enumLit;
	}
	public void setImpl(uk.ac.ukc.cs.kmf.kmfstudio.uml.Foundation.Core.EnumLiteral enumLit) {
		this.enumLit = enumLit;
	}

	/** Enumeration */
	Enumeration_ enum = null;
	public Enumeration_ getEnumeration() {
		if (enumLit != null) {
			enum = processor.getBridgeFactory().buildEnumeration(enumLit.getEnumeration());
		}
		return enum;
	}
	public void setEnumeration(Enumeration_ enum) {
		if (enumLit == null) this.enum = enum;
	}

	/** Name */
	String name = null;
	public String getName() {
		if (enumLit != null) name = enumLit.getName().getBody_();
		return name;
	}
	public void setName(String name) {
		if (enumLit == null) this.name = name;
	}

	/** Type */
	public Classifier getType() {
		return getEnumeration();
	}
	public void setType(Classifier type) {
	}

	/** Get delegate */
	public Object getDelegate() {
		return this.getClass();
	}
	
	/** Accept a Semantic Visitor */
	public Object accept(SemanticsVisitor v, Object data) {
		return  v.visit(this, data);
	}

	/** ToString */
	public String toString() {
		return "EnumLiteral("+getName()+")";
	}

	/** Clone */
	public Object clone() {
		return new EnumLiteralImpl(enumLit, enum, processor);
	}	
}
